<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\sale;


use app\common\model\sale\Sale;
use app\common\logic\BaseLogic;
use think\facade\Config;
use think\facade\Db;


/**
 * Sale逻辑
 * Class SaleLogic
 * @package app\adminapi\logic
 */
class SaleLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {

            $passwordSalt = Config::get('project.unique_identification');
            $password = create_password($params['password'], $passwordSalt);

            Sale::create([
                'sale_group_id' => $params['sale_group_id'],
                'sale_name' => $params['sale_name'],
                'mobile' => $params['mobile'],
                'password' => $password,
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            $up_data = [
                'sale_group_id' => $params['sale_group_id'],
                'sale_name' => $params['sale_name'],
                'mobile' => $params['mobile'],
            ];
            if(!empty($params['password'])){
                $passwordSalt = Config::get('project.unique_identification');
                $password = create_password($params['password'], $passwordSalt);
                $up_data['password'] = $password;
            }
            Sale::where('id', $params['id'])->update($up_data);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public static function delete(array $params): bool
    {
        return Sale::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public static function detail($params): array
    {
        return Sale::findOrEmpty($params['id'])->toArray();
    }
}